/*event,isPC,fullAnimatbanner,scrollStyleV,imglist5,mAlert,imgGeomeScale*/
jQuery.easing.jswing = jQuery.easing.swing;
jQuery.extend(jQuery.easing, {
	def: "easeOutQuad",
	swing: function(e, f, a, h, g) {
		return jQuery.easing[jQuery.easing.def](e, f, a, h, g)
	},
	easeInQuad: function(e, f, a, h, g) {
		return h * (f /= g) * f + a
	},
	easeOutQuad: function(e, f, a, h, g) {
		return -h * (f /= g) * (f - 2) + a
	},
	easeInOutQuad: function(e, f, a, h, g) {
		if ((f /= g / 2) < 1) {
			return h / 2 * f * f + a
		}
		return -h / 2 * (--f * (f - 2) - 1) + a
	},
	easeInCubic: function(e, f, a, h, g) {
		return h * (f /= g) * f * f + a
	},
	easeOutCubic: function(e, f, a, h, g) {
		return h * ((f = f / g - 1) * f * f + 1) + a
	},
	easeInOutCubic: function(e, f, a, h, g) {
		if ((f /= g / 2) < 1) {
			return h / 2 * f * f * f + a
		}
		return h / 2 * ((f -= 2) * f * f + 2) + a
	},
	easeInQuart: function(e, f, a, h, g) {
		return h * (f /= g) * f * f * f + a
	},
	easeOutQuart: function(e, f, a, h, g) {
		return -h * ((f = f / g - 1) * f * f * f - 1) + a
	},
	easeInOutQuart: function(e, f, a, h, g) {
		if ((f /= g / 2) < 1) {
			return h / 2 * f * f * f * f + a
		}
		return -h / 2 * ((f -= 2) * f * f * f - 2) + a
	},
	easeInQuint: function(e, f, a, h, g) {
		return h * (f /= g) * f * f * f * f + a
	},
	easeOutQuint: function(e, f, a, h, g) {
		return h * ((f = f / g - 1) * f * f * f * f + 1) + a
	},
	easeInOutQuint: function(e, f, a, h, g) {
		if ((f /= g / 2) < 1) {
			return h / 2 * f * f * f * f * f + a
		}
		return h / 2 * ((f -= 2) * f * f * f * f + 2) + a
	},
	easeInSine: function(e, f, a, h, g) {
		return -h * Math.cos(f / g * (Math.PI / 2)) + h + a
	},
	easeOutSine: function(e, f, a, h, g) {
		return h * Math.sin(f / g * (Math.PI / 2)) + a
	},
	easeInOutSine: function(e, f, a, h, g) {
		return -h / 2 * (Math.cos(Math.PI * f / g) - 1) + a
	},
	easeInExpo: function(e, f, a, h, g) {
		return f == 0 ? a : h * Math.pow(2, 10 * (f / g - 1)) + a
	},
	easeOutExpo: function(e, f, a, h, g) {
		return f == g ? a + h : h * (-Math.pow(2, -10 * f / g) + 1) + a
	},
	easeInOutExpo: function(e, f, a, h, g) {
		if (f == 0) {
			return a
		}
		if (f == g) {
			return a + h
		}
		if ((f /= g / 2) < 1) {
			return h / 2 * Math.pow(2, 10 * (f - 1)) + a
		}
		return h / 2 * (-Math.pow(2, -10 * --f) + 2) + a
	},
	easeInCirc: function(e, f, a, h, g) {
		return -h * (Math.sqrt(1 - (f /= g) * f) - 1) + a
	},
	easeOutCirc: function(e, f, a, h, g) {
		return h * Math.sqrt(1 - (f = f / g - 1) * f) + a
	},
	easeInOutCirc: function(e, f, a, h, g) {
		if ((f /= g / 2) < 1) {
			return -h / 2 * (Math.sqrt(1 - f * f) - 1) + a
		}
		return h / 2 * (Math.sqrt(1 - (f -= 2) * f) + 1) + a
	},
	easeInElastic: function(f, h, e, l, k) {
		var i = 1.70158;
		var j = 0;
		var g = l;
		if (h == 0) {
			return e
		}
		if ((h /= k) == 1) {
			return e + l
		}
		if (!j) {
			j = k * .3
		}
		if (g < Math.abs(l)) {
			g = l;
			var i = j / 4
		} else {
			var i = j / (2 * Math.PI) * Math.asin(l / g)
		}
		return -(g * Math.pow(2, 10 * (h -= 1)) * Math.sin((h * k - i) * 2 * Math.PI / j)) + e
	},
	easeOutElastic: function(f, h, e, l, k) {
		var i = 1.70158;
		var j = 0;
		var g = l;
		if (h == 0) {
			return e
		}
		if ((h /= k) == 1) {
			return e + l
		}
		if (!j) {
			j = k * .3
		}
		if (g < Math.abs(l)) {
			g = l;
			var i = j / 4
		} else {
			var i = j / (2 * Math.PI) * Math.asin(l / g)
		}
		return g * Math.pow(2, -10 * h) * Math.sin((h * k - i) * 2 * Math.PI / j) + l + e
	},
	easeInOutElastic: function(f, h, e, l, k) {
		var i = 1.70158;
		var j = 0;
		var g = l;
		if (h == 0) {
			return e
		}
		if ((h /= k / 2) == 2) {
			return e + l
		}
		if (!j) {
			j = k * .3 * 1.5
		}
		if (g < Math.abs(l)) {
			g = l;
			var i = j / 4
		} else {
			var i = j / (2 * Math.PI) * Math.asin(l / g)
		}
		if (h < 1) {
			return -.5 * g * Math.pow(2, 10 * (h -= 1)) * Math.sin((h * k - i) * 2 * Math.PI / j) + e
		}
		return g * Math.pow(2, -10 * (h -= 1)) * Math.sin((h * k - i) * 2 * Math.PI / j) * .5 + l + e
	},
	easeInBack: function(e, f, a, i, h, g) {
		if (g == undefined) {
			g = 1.70158
		}
		return i * (f /= h) * f * ((g + 1) * f - g) + a
	},
	easeOutBack: function(e, f, a, i, h, g) {
		if (g == undefined) {
			g = 1.70158
		}
		return i * ((f = f / h - 1) * f * ((g + 1) * f + g) + 1) + a
	},
	easeInOutBack: function(e, f, a, i, h, g) {
		if (g == undefined) {
			g = 1.70158
		}
		if ((f /= h / 2) < 1) {
			return i / 2 * f * f * (((g *= 1.525) + 1) * f - g) + a
		}
		return i / 2 * ((f -= 2) * f * (((g *= 1.525) + 1) * f + g) + 2) + a
	},
	easeInBounce: function(e, f, a, h, g) {
		return h - jQuery.easing.easeOutBounce(e, g - f, 0, h, g) + a
	},
	easeOutBounce: function(e, f, a, h, g) {
		if ((f /= g) < 1 / 2.75) {
			return h * 7.5625 * f * f + a
		} else {
			if (f < 2 / 2.75) {
				return h * (7.5625 * (f -= 1.5 / 2.75) * f + .75) + a
			} else {
				if (f < 2.5 / 2.75) {
					return h * (7.5625 * (f -= 2.25 / 2.75) * f + .9375) + a
				} else {
					return h * (7.5625 * (f -= 2.625 / 2.75) * f + .984375) + a
				}
			}
		}
	},
	easeInOutBounce: function(e, f, a, h, g) {
		if (f < g / 2) {
			return jQuery.easing.easeInBounce(e, f * 2, 0, h, g) * .5 + a
		}
		return jQuery.easing.easeOutBounce(e, f * 2 - g, 0, h, g) * .5 + h * .5 + a
	}
});
var Yeffect = {
	event: {
		start: function(dom, fn) {
			dom = $(dom).eq(0);
			if (!this.move.touchs) {
				this.move.touchs = {}
			};
			if (!this.start.ISpc) {
				this.start.ISpc = Yeffect.isPC()
			};
			var thiso = this;
			if (this.start.ISpc) {
				thiso.move.touchs = null;
				dom.mousedown(function(e) {
					thiso.move.touchs = e;
					fn.call(this, e)
				})
			} else {
				dom[0].addEventListener("touchstart", function(e) {
					var touchs = e.touches;
					var thiskey = Object.keys(touchs);
					var minlen = thiskey.length - 2;
					minlen = Math.max(minlen, 0);
					var thistouch = touchs[thiskey[minlen]];
					for (var o in touchs) {
						if (!thiso.move.touchs[thistouch.identifier]) {
							var datsA = {};
							var datsM = {};
							for (var p in thistouch) {
								datsA[p] = thistouch[p];
								datsM[p] = thistouch[p];
							};
							var newdtas = {
								dataS: datsA,
								dataM: datsM
							};
							thiso.move.touchs[thistouch.identifier] = JSON.parse(JSON.stringify(
								newdtas))
						}
					};
					thistouch.preventDefault = function() {
						e.preventDefault()
					};
					fn.bind(this)(thistouch, touchs)
				})
			}
		},
		move: function(dom, fn) {
			if (!this.move.touchs) {
				this.start(dom, function() {})
			};
			dom = $(dom).eq(0);
			var thiso = this;
			if (this.start.ISpc) {
				dom.mousemove(function(e) {
					if (thiso.move.touchs) {
						e.mousedown = true;
						e.deltaX = e.pageX - thiso.move.touchs.pageX;
						e.deltaY = e.pageY - thiso.move.touchs.pageY;
					} else {
						e.deltaX = 0;
						e.deltaY = 0;
						e.mousedown = false;
					};
					fn.call(this, e)
				})
			} else {
				dom[0].addEventListener("touchmove", function(e) {
					var touchs = e.touches;
					for (var o in touchs) {
						var idter = touchs[o].identifier;
						if (idter != undefined) {
							if (touchs[o].pageX != thiso.move.touchs[idter].dataM.pageX || touchs[o]
								.pageY != thiso.move.touchs[idter].dataM.pageY) {
								thiso.move.touchs[idter].dataM.pageX = touchs[o].pageX;
								thiso.move.touchs[idter].dataM.pageY = touchs[o].pageY;
								var thistouch = touchs[o];
								thistouch.preventDefault = function() {
									e.preventDefault()
								};
								thistouch.deltaX = thiso.move.touchs[idter].dataM.pageX - thiso.move
									.touchs[idter].dataS.pageX;
								thistouch.deltaY = thiso.move.touchs[idter].dataM.pageY - thiso.move
									.touchs[idter].dataS.pageY;
								thiso.move.touchs[idter].deltaX = thistouch.deltaX;
								thiso.move.touchs[idter].deltaY = thistouch.deltaY;
								fn.bind(this)(thistouch, touchs)
							}
						};
					}
				})
			}
		},
		end: function(dom, fn) {
			if (!this.move.touchs) {
				this.start(dom, function() {})
			};
			dom = $(dom).eq(0);
			var thiso = this;
			if (this.start.ISpc) {
				dom.mouseup(function(e) {
					if (thiso.move.touchs) {
						e.deltaX = e.pageX - thiso.move.touchs.pageX;
						e.deltaY = e.pageY - thiso.move.touchs.pageY;
					} else {
						e.deltaX = 0;
						e.deltaY = 0;
					};
					e.mousedown = false;
					thiso.move.touchs = null;
					fn.call(dom[0], e)
				})
			} else {
				dom[0].addEventListener("touchend", function(e) {
					var touchs = e.touches;
					var curkey = [];
					for (var o in touchs) {
						if (touchs[o].identifier != undefined) {
							curkey.push(touchs[o].identifier + "")
						}
					};
					for (var t in thiso.move.touchs) {
						if (curkey.indexOf(t) < 0) {
							var touchtT = thiso.move.touchs[t];
							if (!touchtT.deltaY && touchtT.deltaY != 0) {
								touchtT.deltaX = 0;
								touchtT.deltaY = 0;
							};
							fn.bind(this)(touchtT);
							delete thiso.move.touchs[t];
						}
					};
				})
			}
		}
	},
	isPC: function() {
		var userAgentInfo = navigator.userAgent;
		var Agents = new Array("Android", "iPhone", "SymbianOS", "Windows Phone", "iPad", "iPod");
		var flag = true;
		for (var v = 0; v < Agents.length; v++) {
			if (userAgentInfo.indexOf(Agents[v]) > -1) {
				flag = false;
				break
			}
		}
		return flag
	},
	fullAnimatbanner: function(obj1, obj2, num, btnL, btnR, css, time, aniTimer, ismouseover, easingstr) {
		num = num || "";
		btnL = btnL || "";
		btnR = btnR || "";
		css = css || "current";
		time = time || 5e3;
		aniTimer = aniTimer || 300;
		easingstr = easingstr || "linear";
		ismouseover = ismouseover || false;
		var obj1Obj = $(obj1);
		var obj2Obj = $(obj2);
		var numObj = $(num);
		var btnLObj = $(btnL);
		var btnRObj = $(btnR);
		obj1Obj.css("width", "100%");
		obj2Obj.css({
			position: "absolute",
			top: 0,
			left: "100%",
			width: "100%"
		});
		var liliength = obj2Obj.length;
		var curptins = 0;
		var setIntervalsAAA;
		obj2Obj.eq(curptins).css({
			left: 0
		});
		numObj.removeClass(css).eq(curptins).addClass(css);
		obj2Obj.removeClass(css).eq(curptins).addClass(css);
		numObj.click(function() {
			var curindex = numObj.index(this);
			if (curindex != curptins) {
				animatgundxz(curindex, true)
			}
		});
		btnLObj.click(function() {
			if(liliength>1){
				if (curptins - 1 < 0) {
					animatgundxz(liliength - 1, false)
				} else {
					animatgundxz(curptins - 1, false)
				}
			}
			
		});
		btnRObj.click(function() {
			if(liliength>1){
				if (curptins + 1 > liliength - 1) {
					animatgundxz(0, true)
				} else {
					animatgundxz(curptins + 1, true)
				}
			}
			
		});
		//setIntervalsAAA = setInterval(functionTimegd, time);
	
		function functionTimegd() {
			if (curptins + 1 > liliength - 1) {
				animatgundxz(0, true)
			} else {
				animatgundxz(curptins + 1, true)
			}
		};
	
		function animatgundxz(cuet, drect) {
			//clearInterval(setIntervalsAAA);
			//setIntervalsAAA = setInterval(functionTimegd, time);
			obj2Obj.stop().css({
				left: "100%"
			});
			if (drect) {
				obj2Obj.eq(cuet).stop().css({
					left: "100%"
				});
				obj2Obj.eq(cuet).animate({
					left: 0
				}, aniTimer, easingstr);
				obj2Obj.eq(curptins).stop().css({
					left: "0%"
				});
				obj2Obj.eq(curptins).animate({
					left: "-100%"
				}, aniTimer, easingstr)
			} else {
				obj2Obj.eq(cuet).css({
					left: "-100%"
				}).animate({
					left: 0
				}, aniTimer, easingstr);
				obj2Obj.eq(curptins).css({
					left: "0%"
				}).animate({
					left: "100%"
				}, aniTimer, easingstr)
			};
			curptins = cuet;
			numObj.removeClass(css).eq(curptins).addClass(css);
			obj2Obj.removeClass(css).eq(curptins).addClass(css)
		};
		if (ismouseover) {
			obj1Obj.hover(function() {
				//clearInterval(setIntervalsAAA)
			}, function() {
				//setIntervalsAAA = setInterval(functionTimegd, time)
			})
		};
		$(window).resize(function() {
			obj2Obj.stop().css({
				left: "100%"
			});
			obj2Obj.eq(curptins).stop().css({
				left: 0
			})
		})
	},
	scrollStyleV: function(Diva, divb, tiaoa, tiaob) {
		// var isPcsd = this.isPC();
		// if (!isPcsd) return;
		tiaoa = tiaoa || "";
		tiaob = tiaob || "";
		var DivA_obj = $(Diva);
		var divb_obj = $(divb);
		var tiaoA_obj = $(tiaoa);
		var tiaob_obj = $(tiaob);
		//console.log(divb_obj)
		var bilizhi;
		var bilizhis2;
		divb_obj.find("img").load(sethanshu);
		sethanshu();

		function sethanshu() {
			var DivA_objH = DivA_obj.height();
			var divb_objH = divb_obj.height();
			bilizhi = DivA_objH / divb_objH;
			if (bilizhi >= 1) {
				tiaoA_obj.hide()
			} else {
				//console.log(DivA_obj.scrollTop())
				tiaoA_obj.show();
				tiaob_obj.height(bilizhi * 100 + "%").css("top", DivA_obj.scrollTop() * bilizhi);
			}
		};
		$(window).resize(sethanshu);
		DivA_obj.scroll(sethanshu);
		tiaob_obj.mousedown(function(e) {
			var yuanshiutp = e.pageY;
			var scscctop = DivA_obj.scrollTop();
			bilizhis2 = tiaob_obj.height() / DivA_obj.height();
			$(document).unbind("mousemove");
			$(document).mousemove(function(u) {
				DivA_obj.scrollTop(scscctop + (u.pageY - yuanshiutp) / bilizhis2);
				return false
			});
			return false
		});
		$(document).mouseup(function() {
			$(document).unbind("mousemove")
		})
	},
	imglist5: function(ul, btnL, btnR, tagname, posArry, deft, textcon, tag, timenum, easingstr) {
		easingstr = easingstr || "linear";
		timenum = timenum || 300;
		var btnLo = $(btnL);
		var btnRo = $(btnR);
		var ulo = $(ul);
		var lio = ulo.find(tagname);
		var poinshu = [];
		deft = deft || 0;
		deft = deft + 1;
		textcon = textcon || "";
		tag = tag || "";
		var deftint = deft - 1;
		var curInt = deft - 1;
		var curdanw = 0;
		textcon = textcon || "";
		tag = tag || "";
		var textcono = $(textcon);
		lio.each(function(index) {
			poinshu.push(index + deftint);
			if (index + deftint > 4) {
				$(this).css({
					marginLeft: posArry[4].x + 150,
					marginTop: posArry[4].y,
					width: posArry[4].w,
					height: posArry[4].h,
					zIndex: 1
				})
			} else {
				$(this).css({
					marginLeft: posArry[index + deftint].x,
					marginTop: posArry[index + deftint].y,
					width: posArry[index + deftint].w,
					height: posArry[index + deftint].h,
					zIndex: posArry[index + deftint].z
				})
			}
		});
		textcono.text(lio.eq(3 - deft).find(tag).text());
		btnLo.click(function() {
			if (curInt < 2) {
				curInt++;
				curdanw = 1;
				setGUND()
			}
		});
		btnRo.click(function() {
			if (poinshu[poinshu.length - 1] > 2) {
				curInt--;
				curdanw = -1;
				setGUND()
			}
		});

		function setGUND() {
			for (var i = 0; i < poinshu.length; i++) {
				poinshu[i] += curdanw;
				var curzhi = poinshu[i];
				if (!(curzhi < 0 || curzhi > 4)) {
					lio.eq(i).css({
						zIndex: posArry[curzhi].z
					}).animate({
						marginLeft: posArry[curzhi].x,
						marginTop: posArry[curzhi].y,
						width: posArry[curzhi].w,
						height: posArry[curzhi].h
					}, timenum, easingstr);
					if (curzhi == 2) {
						textcono.text(lio.eq(i).find(tag).text())
					}
				};
				if (curzhi < 0) {
					lio.eq(i).css({
						zIndex: 1
					}).animate({
						marginLeft: posArry[0].x - 150,
						marginTop: posArry[0].y,
						width: posArry[0].w,
						height: posArry[0].h
					}, timenum, easingstr)
				};
				if (curzhi > 4) {
					lio.eq(i).css({
						zIndex: 1
					}).animate({
						marginLeft: posArry[4].x + 228,
						marginTop: posArry[4].y,
						width: posArry[4].w,
						height: posArry[4].h
					}, timenum, easingstr)
				}
			};
		}
	},
	mAlert: function(text, time, isscroll) {
		var htmls = $("html");
		var mAlertClass = $(".mAlertClass");
		if (mAlertClass.length > 0) mAlertClass.remove();
		time = time || 3e3;
		isscroll = isscroll || false;
		var divalert = $(
			"<div class='mAlertClass' style='position:fixed; width:100%; height:100%; z-index:10000; left:0px; top:0px;'><div style='font-size:13px; color:#fff; background:rgba(0,0,0,0.6); line-height:20px;  text-align:center; overflow:hidden; left:50%; top:50%; padding:10px; margin-top:-20px; position:absolute; border-radius:5px; transform: translateX(-50%); -webkit-transform: translateX(-50%);'>" +
			text + "</div></div>");
		$("body").append(divalert);

		function removets() {
			divalert.remove();
			htmls.css({
				borderRight: 0,
				overflowY: "visible"
			})
		};
		if (!isscroll) {
			if (window["addEventListener"]) {
				divalert[0].addEventListener("touchstart", function(e) {
					e.preventDefault()
				})
			};
			var divapen = $("<div></div>");
			var divapenn = $("<div></div>");
			divapen.css({
				clear: "both",
				width: 100,
				height: 100,
				overflowY: "scroll",
				position: "absolute",
				top: 0,
				left: 0
			});
			divapen.append(divapenn);
			$("body").append(divapen);
			htmls.css({
				overflow: "hidden",
				borderRight: divapen.width() - divapenn.width() + "px solid #eee"
			});
			divapen.remove()
		};
		setTimeout(removets, time);
		return removets
	},
	imgGeomeScale: function(obj, nocent) {
		var bder = nocent || false;
		$(obj).each(function(i) {
			var img = $(this);
			if (img.attr("data-set")) {
				return
			};
			img.attr("data-style", "yes");
			var realWidth;
			var realHeight;
			var objwidh = img.width();
			var objhet = img.height();
			$("<img/>").attr("src", img.attr("src")).load(function() {
				realWidth = this.width;
				realHeight = this.height;
				if (objwidh / objhet > realWidth / realHeight) {
					var widthhou = objhet * realWidth / realHeight;
					img.width(widthhou);
					if (!bder) {
						img.css({
							paddingLeft: (objwidh - widthhou) / 2,
							paddingRight: (objwidh - widthhou) / 2
						})
					}
				} else {
					var heithou = objwidh * realHeight / realWidth;
					img.height(heithou);
					if (!bder) {
						img.css({
							paddingTop: (objhet - heithou) / 2,
							paddingBottom: (objhet - heithou) / 2
						})
					}
				};
			})
		})
	}
};
